    <!DOCTYPE html>
    <html>
    
        <head>
            <meta charset="utf-8">
            <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
            <title>I2C Bit banging</title>
            <meta name="description" content="I2C implementation by bit banging.">
            <link rel="stylesheet" href="main.css">
            <script src="processing.js" ></script>
        <link rel="icon" type="img/png" href="icon.png">
        </head>
        <body>
            
             <img alt="pattern" src="Udayan Umapathi2.png" height="80"
                width="300">
            
            <br>
            <br>

           
            
            <ulh>
                <lih><a  class="menu" href="index.html" >home</a></lih>
                <lih><a class="menu" href="projects.html" >projects</a></lih>
                <lih><a class="menu" href="research.html">research</a></lih>
                <lih><a class="menu" href="hobby.html">obsession</a></lih>
            </ulh>
        
            <hr class="style-one"/>
            
            <p> <b>I2C by Bit-banging</b> by Udayan Umapathi</p>
            <hr class="style-six"> 
            
            <p><a href="http://en.wikipedia.org/wiki/I%C2%B2C" target="_blank">I2C</a> is one of the widely adopted serial communication protocol in the embedded world. Originally developed by Philips, 30 years ago, it went on to become one of the most generic serial protocol (UART, SPI and USB are other popular serial protocols). </p>
            
            <img alt="Serial Communication"
                src="serial.png" height="380" width="480">
            <p>Image source: NXP Semiconductors</p>
            
            <p>Most of the micro-controllers have built-in hardware to handle I2C interface. Micro-controller manufactures like TI, NXP, Atmel integrate more and more features in to their micro-controller devices in order to differentiate from others and sell their chip. However, the situation was not the same a few years ago. Even the most common communication protocol was not available as on-chip module. With more on-chip features, the cost of the chip was higher. The trend was to create software stack to implement these features. </p>
            
            <p>Back in 2007, I worked with Fujitsu Microelectronics to implement a complete stack for I2C protocol for one of their Micro-controller family called <a href="http://www.fujitsu.com/downloads/MICRO/fme/documentation/ad07.pdf" target="_blank">F2MC</a>. The stack was implemented based on the <a href="http://www.nxp.com/documents/application_note/AN10216.pdf" target="_blank">I2C</a> spec provided by Philips. The implementation was done using what is popularly known as <a href="http://en.wikipedia.org/wiki/Bit_banging" target="_blank">Bit-banging</a>. In principle, you would have a software sequencing through a set of state machines. The state-machine would control the timing and digital signal levels of the two I2C pins (I2C Data and I2C Clock). </p>
            
            <p>Through this experience I learnt how software can provide the functionality of a hardware module. I also learnt that by implementing a software stack, you are essentially stealing away valuable computation cycles from the CPU, which may not be a good idea if the micro-controller is used in a timing-critical application. Hardware vendors quite often use the software bit-banging technique to provide customers with additional libraries and promote their product. The implementation also showed me how to translate the written specification of a system into a real world application. </p>
            
            <hr class="style-seven" />            
            <p class="left">copyrights©2013 Udayan</p>
            <br style="clear: both" /> 
            
       </body>
    </html>
